<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { onMounted, ref, inject } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { storeToRefs } from 'pinia';
import { useI18n } from 'vue-i18n';
import { useMetaStore } from '@/stores/meta';
import { request } from '@/lib/request';
import Freeform from '@/components/freeform/Index.vue';
import Schedule from '@/components/schedule/Index.vue';
import Timeline from '@/components/timeline/Index.vue';
import Input from '@/components/general/form/Input.vue';
import Button from '@/components/general/Button.vue';
import { useBaseStore } from '@/stores/base';
import { notificationStatus } from '@/enums/enums';

const { t } = useI18n();
const $t = t;
document.title = $t('login.title');
const baseStore = useBaseStore();
const { message, status } = storeToRefs(baseStore);
const route = useRoute()
const router = useRouter();
const metaStore = useMetaStore();
const { userType: storeUserType, hashcode, noPassHash, adminMail, dashboard, paneType } = storeToRefs(metaStore);
const showLogin = ref(true);
const password = ref('');
const boardType = ref(null);
const error = ref('');
const backendOffline = ref(false);
let configuration = inject<any>('configuration');

onMounted(async () => {
    if (route.params.id) {
        hashcode.value = String(route.params.id);
        let result = await request('GET', configuration.apiServer + '/api/pane/' + hashcode.value);
        if (!result || !result.success) {
            message.value = $t('indexPage.error.notFound');
            status.value = notificationStatus.DANGER; 
            router.push({ name: "home" });
        }
    } else {
        message.value = $t('indexPage.error.notFound');
        status.value = notificationStatus.DANGER; 
        router.push({ name: "home" });
    }
});

const submit = async () => {
    if (password.value.length > 5) {
        error.value = '';
        try {
            let response = await request('POST', configuration.apiServer + '/api/boarddata/login', { id: hashcode.value, password: password.value, type: storeUserType.value });
            if (response && response.success) {
                boardType.value = response.type;
                paneType.value = response.type;
                adminMail.value = response.adminMail;
                if (response.noPassHash)
                    noPassHash.value = response.noPassHash;
                if (response.dashboard)
                    dashboard.value = response.dashboard;
                showLogin.value = false;
            }
            else if (response && response.success !== undefined && !response.success) {
                error.value = t('general.variables.password.error');
            }
            else if (!response.status) {
                backendOffline.value = true;
                error.value = t('general.errors.backendOffline');
            }
        }
        catch (err) {
            console.error(err);
        }

    }
}

</script>
<template>
    <div class="bg-gray-100 h-screen">
        <div class="flex box-content max-w-xl mx-auto px-4 h-full items-center" v-if="showLogin">
            <div class="relative box-border transition duration-100 ease-in-out rounded-lg w-full bg-white shadow-md">
                <div class="p-4 flex flex-col gap-2">
                    <strong>{{ $t("login.label") }}</strong>
                    <strong class="text-red-600" v-if="error">{{ error }}</strong>
                    <div class="w-full" v-if="!backendOffline">
                        <Input id="password-text-field" v-model="password" type="password" icon="key"
                                :placeholder="$t('placeholder.password')"
                                autocomplete="current-password" @keyup.enter="submit" />
                        <Button :variant="password && password.length > 5?'confirm':'disabled'" @click="submit">{{ $t("adminMenu.passwordReset.submit")
                                }}</Button>
                        
                    </div>
                </div>
            </div>
        </div>
        <div v-if="!showLogin">
            <Freeform v-if="boardType === 'freeform'" />
            <Schedule v-else-if="boardType === 'schedule' || boardType === 'stream'" />
            <Timeline v-else-if="boardType === 'timeline'" />
        </div>
    </div>
</template>